Capisuite

Aus Neobiker's Wiki
Wechseln zu: Navigation, Suche

Zurück zum Portal

Inhaltsverzeichnis

Capisuite Erweiterung

Bei der Umstellung von VBox unter Debian Sarge auf Capisuite unter Etch habe ich schmerzlich die Möglichkeit der individuellen Programmierung des Anrufbeantworters vermisst. Nachdem ich keine verbesserten incoming.py Files im Web gefunden habe, habe ich auf die schnelle Python gelernt und die fehlende Funktion selbst implementiert.

Individuelle Programmierung

In den Konfigfiles können Programme hinterlegt werden, die in Abhängigkeit von Zeit, Datum oder Telefonnummern (des Anrufers oder der Zielnummer) unterschiedlich reagieren. Ich nutze z.B. je eine eigene MSN für Privates, Geschäftliches und Fax. Die Geschäftsnummer klingelt nur Mo-Fr zw. 8:30 und 17:00, sonst aktiviert sich direkt der AB mit einer geschäftlichen Ansage. Wochenenden, Feiertage und Geburtstage sind zusätzlich hinterlegt. Familie und Freunde können uns Abends z.B. länger erreichen, als unbekannte Anrufer, die Nachrichten werden auch länger aufgezeichnet. Die Möglichkeiten sind nahezu beliebig.

  • Die Programme werden fortlaufend (!) nummeriert, beginnend bei prog1
  • Das erste Programm prog1 ... progX das match'ed (Zeit, Datum, etc.) wird verwendet, deshalb ist die Reihenfolge relevant!
  • Die Einträge dates und group können als eigene Section im Konfigfile definiert werden (siehe holiday, family, friends)
  • Die Telefonnummern müssen so definiert sein, wie sie im Logfile (/var/log/capisuite.log) erscheinen, d.h. üblicherweise 0911 12345678 (nicht: +49 (911) 12345678).
  • Es kann ein eigenes Telefonbuch verwendet werden. Einträge darin werden mit Namen gelistet (Email/Fax Email enthält den Namen und die Nummer)


Mein Konfig-File /etc/capisuite/answering_machine.conf sieht in etwa wie folgt aus und sollte weitestgehend selbsterklärend sein.
[GLOBAL]
audio_dir="/usr/share/capisuite/"
voice_user_dir="/var/spool/capisuite/users/"
user_audio_files="1"
voice_delay="15"
announcement="ab_buis.la"
record_length="60"
record_silence_timeout="5"
voice_email_from="Anrufbeantworter <ab@neobiker.de>"

[priv]
voice_numbers="12345678"
announcement="ab_priv.la"
voice_action="MailAndSave"
voice_delay="10"
record_length="90"
voice_email_from="ab@neobiker.de"
voice_email="Anrufbeantworter (Priv) <ab@neobiker.de>"
pin="1111"
# ----- vbox programming:
# ----- dates   time frame      week days       file to play    delay   record  group
prog1=  *       22:00-07:00     *               ab_priv.la      5       120     family,friends
prog2=  *       *               *               ab_priv.la      15      120     family,friends
prog3=  *       22:00-07:00     *               ab_priv.la      5       120     *
prog4=  *       *               *               ab_priv.la      10      120     *

[buis]
voice_numbers="22233345"
announcement="ab_buis.la"
voice_action="MailAndSave"
voice_delay="10"
record_length="60"
voice_email_from="Anrufbeantworter (Buis) <ab@neobiker.de>"
voice_email="ab@neobiker.de"
pin="2222"
# ----- vbox programming:
# ----- dates   time frame      week days       file to play    delay   record  group
prog1=  *       22:00-07:00     *               ab_priv.la      5       120     family,friends
prog2=  *       *               *               ab_priv.la      15      120     family,friends
prog3=  holiday *               *               ab_buis.la      1       90      *
prog4=  *       *               SA,SO           ab_buis.la      1       90      *
prog5=  *       17-08:29        *               ab_buis.la      1       90      *
prog6=  *       *               *               ab_buis.la      10      90      *

[holiday]
Weihnachten=24.12.,25.12.,26.12.
Ostern=6.4.2007,9.4.2007,17.5.2007,28.5.2007.,7.6.2007
Sonstige=1.1.,6.1.,1.5.,3.10.,1.11.
Birthdays=19.5.

Zusätzlich habe ich ein Telefonbuch definiert, in welchem auch die verschiedenen Gruppen (s.o. das Konfigfile / AB-Programme) definiert sind (Familie, Freunde, ...): /etc/capisuit/phonebook.conf

[GLOBAL]
Privat = 123456
Geschäft = 123457
Fax = 123458

[family]
Eltern=01234 12345, 0175123456,0172 234567
Oma=123456789

[friends]
Karl=12345,017134566789
Peter=0170123456, 0911 123412

[others]
Arzt = 12345
Werkstatt = 12346789
Buero = 123 345 567

Telefonnummern, welche nicht im Telefonbuch stehen, werden per online reverse lookup unter www.dasoertliche.de nachgeschlagen und sofern gefunden unter /var/cache/tbident/phonebook.cache gespeichert.

Der Anrufbeantworter (Fax dito) sendet mir eine Email mit einer Wav-Datei (oder PDF bei Fax) und den wichtigsten Info's:

From:    Anrufbeantworter (Priv) <ab@neobiker.de>
To:      ab@neobiker.de
Subject: Nachricht von Unbekannt fuer Privat
Anlage:  voice-184.wav

Anrufer: Unbekannt (0911987654321)
         
Laenge:  31 Sek.
Datum:   Di 11 Sep 2007 13:57:43 CEST
Nummer:  Privat (123456)

Siehe Anhang.
Das File wurde gespeichert unter: /var/spool/capisuite/users/ab/received/voice-184.la

Downloads

Download ISDN Files

Erweiterte Scripts

Ich habe die Files

  • incoming_adv.py
  • idle_adv.py
  • tbident.sh

erstellt. Die ersten beiden werden in /etc/capisuite/capisuite.conf aktiviert, das letzte zur Telefonbuch-Identifikation (tbident.sh) muss im Standardpfad installiert werden (z.B. unter /usr/bin/tbident.sh).

Die Scripts sind für eine Deutsche Ausgabe optimiert worden. Es wird einmal setlocale(de_DE) verwendet. Deshalb sind auf dem System die deutschen locales notwendig, diese können unter Debian mit dpkg-reconfigure locales erzeugt werden.

Hinweis: Die Scripts müssen zuerst compiliert werden!

Folgendes Script compiliert die CapiSuite Python Scripts:

#!/bin/sh
PYTHON=python2.4
DIRLIST=" /usr/lib/capisuite "
for i in $DIRLIST ; do
  $PYTHON -O /usr/lib/$PYTHON/compileall.py -q $i;
  $PYTHON /usr/lib/$PYTHON/compileall.py -q $i;
done

File: /usr/lib/capisuite/incoming_adv.py

Hier ist das erweiterte File /usr/lib/capisuite/incoming_adv.py.

File: /usr/lib/capisuite/idle_adv.py

Das idle.py File benötigt eine kleine Änderung (ganz unten im Script, mit '+' markiert), damit die neuen Sections nicht zu einer Fehlermeldung (über nicht existierenden System-User) führen.

#               idle_adv.py - default script for capisuite
#              ---------------------------------------------
#    copyright            : (C) 2007 neobiker
#    Version              : 1.1
#    Date                 : 03.01.2007
#
#    original script:
#    copyright            : (C) 2002 by Gernot Hillier
#    email                : gernot@hillier.de
#    version              : Revision: 1.8.2.2
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#

import os,re,time,pwd,fcntl
# capisuite stuff
import capisuite,cs_helpers

def idle(capi):
        config=cs_helpers.readConfig()
        spool=cs_helpers.getOption(config,"","spool_dir")
        if (spool==None):
                capisuite.error("global option spool_dir not found.")
                return

        done=os.path.join(spool,"done")+"/"
        failed=os.path.join(spool,"failed")+"/"

        if (not os.access(done,os.W_OK) or not os.access(failed,os.W_OK)):
                capisuite.error("Can't read/write to the necessary spool dirs")
                return

        userlist=config.sections()
        userlist.remove('GLOBAL')

        for user in userlist: # search in all user-specified sendq's
+               # neobiker: skip none user sections
+               if not (config.has_option(user,'voice_numbers') or config.has_option(user,'fax_numbers')):
+                       continue
                userdata=pwd.getpwnam(user)
                ...

File: /usr/bin/tbident.sh

Das Skript tbident.sh sucht mit lynx (muss installiert sein!) eine Telefonnummer online unter www.dasoertliche.de und cached jede Suche unter /var/cache/tbident/phonebook:

File /usr/bin/tbident.sh:

#!/bin/sh
# tbident.sh
#
# Rückwärtssuche Telefonnummer -> Eintrag im Telefonbuch
#
# Usage: tbident.sh "09123 34 45 67"
# Ursprung: altes tbident.sh des VDR-Portal's
#
# Gefundene Telefonnummern werden gecached unter:
# >>> /var/cache/tbident/phonebook <<<
#
# $Log: tbident.sh,v $
# Revision 1.4  2009/07/05 11:33:27  root
# added autom. updates of (grep) search parameters
#
# Revision 1.3  2008/06/05 11:35:00  root
# *** empty log message ***
#
# Revision 1.2  2008/06/05 11:33:27  root
# updated html syntax
#
# Revision 1.1  2007/09/09 15:50:43  root
# Initial revision
#

set -e

NR="$@"
NUMMER=`echo "$NR" | tr -d ' ()' | sed -e "s/^\+49//"`
NAME=""
DETAILS=""

URL="http://www.dasoertliche.de/?form_name=search_inv&action=1&&ph="
CONTEXT='Trefferliste'

CACHE=/var/cache/tbident/phonebook
TMPFILE=/tmp/tbident_$$
TMPVARS=/var/cache/tbident/tbident.vars
TIMEOUT=3

if [ ! -x /usr/bin/lynx ]; then
  echo "Error: Lynx not installed."
  exit 1
fi

if [ ! -e /usr/bin/tbident-check.sh ]; then
  echo "Error: tbident-check.sh not installed."
  exit 1
fi

if [ ! -e $CACHE ]; then
    mkdir -p `dirname $CACHE`
    touch $CACHE
fi
grep "^${NUMMER}|" $CACHE && exit 0

# read variables (daily per cron updated)
if [ ! -e "$TMPVARS" ]; then
    tbident-check.sh
fi
. $TMPVARS

# get 1.st match (-m1) of list
GREP="grep $CONTEXT $GREP_OPT -m1 $TMPFILE"

lynx "${URL}${NUMMER}" -dump -nolist -connect_timeout=$TIMEOUT >$TMPFILE 2>/dev/null

NAME=`$GREP | awk "{ if (NR == $NAME_LINE) print }" | sed -e "s/$NAME_FILTER\$//g" |
              sed -e 's/^ *//' -e 's/ *$//'`
DETAILS=`$GREP | awk "{ if (NR == $ADRS_LINE) print }" | sed -e "s/$ADRS_FILTER\$//g" |
              sed -e 's/^ *//' -e 's/ *$//'`

if [ -n "$NAME" ]; then
    echo "$NUMMER|$NAME|$DETAILS"
    echo "$NUMMER|$NAME|$DETAILS" >> $CACHE
else
    echo "$NR|Unbekannt|"
    echo "$NR|Unbekannt|" >> $CACHE
fi

rm $TMPFILE

File /usr/bin/tbident-check.sh:

#!/bin/sh
# tbident-check.sh
#
# Aktuelle Syntax prüfen und Variablen autom. setzen
# Rückwärtssuche Telefonnummer -> Eintrag im Telefonbuch
#

NR="091329040"
NUMMER=`echo "$NR" | tr -d ' ()' | sed -e "s/^\+49//"`

URL="http://www.dasoertliche.de/?form_name=search_inv&action=1&&ph="
CONTEXT='Trefferliste'
NAME=""
DETAILS=""

TMPFILE=/tmp/tbident_$$
TMPVARS=/var/cache/tbident/tbident.vars
TIMEOUT=3

if [ ! -x /usr/bin/lynx ]; then
  echo "Error: Lynx not installed."
  exit 1
fi

if [ ! -e "$TMPVARS" ]; then
    cat > $TMPVARS << EOT
NAME_LINE=0
ADRS_LINE=0
NAME_FILTER=
ADRS_FILTER=
GREP_OPT=
EOT
    chmod a+rx $TMPVARS
fi
mv $TMPVARS ${TMPVARS}.bak

lynx "${URL}${NUMMER}" -dump -nolist -connect_timeout=$TIMEOUT -dont_wrap_pre >$TMPFILE 2>/dev/null ||
     { echo "Error $0: Lynx failed."
       exit 1
     }

awk '
    BEGIN {
      srch="Trefferliste"
      nam="Herzo Werke GmbH"
      adr="Schießhausstr. 9, 91074 Herzogenaurach"
      srch_line=0
      nam_line=0
      adr_line=0
     }
    /Trefferliste/ { srch_line = NR }

    /Herzo Werke GmbH/ {
      nam_line = NR
      drop_nam = index($0, nam) + length(nam)
      drop_nam_str = substr($0, drop_nam)
      }
    /Schießhausstr. 9, 91074 Herzogenaurach/ {
      adr_line = NR
      drop_adr = index($0, adr) + length(adr)
      drop_adr_str = substr($0, drop_adr)
      }
    END {
      print "GREP_OPT=\"-A" max(adr_line, nam_line) - srch_line "\""
      print "NAME_LINE=\"" nam_line - srch_line + 1 "\""
      print "ADRS_LINE=\"" adr_line - srch_line + 1 "\""
      if ( length(drop_nam_str) ) printf "NAME_FILTER=\"%s\"\n", drop_nam_str
      else print "NAME_FILTER="
      if ( length(drop_adr_str) ) printf "ADRS_FILTER=\"%s\"\n", drop_adr_str
      else print "ADRS_FILTER="
    }
    function max(a,b)
    {
      if (a<b) return b
      else return a
    }
' $TMPFILE > $TMPVARS ||
       { echo "Error $0: Awk failed."
         mv ${TMPVARS}.bak $TMPVARS
         exit 1
       }

chmod a+rx $TMPVARS

diff $TMPVARS ${TMPVARS}.bak >/dev/null || echo "Info $0: Vars updated"
rm $TMPFILE

Zurück zum Portal